import sys, os, urllib2, re
from kodiswift import xbmc, xbmcgui, CLI_MODE
from kodiswift import Plugin, storage
from resources.lib.content import util, ContentSources
#from resources.lib.content import Downloader
#from twisted.web import client
#from twisted.internet import reactor, defer

#plugin = Plugin()
#plugin.load_addon_settings()
#playlist = plugin.get_setting("general_playlist",str)
#proxy_url = plugin.get_setting("general_proxy_url",str)

cunicode = lambda s: s.decode("utf8") if isinstance(s, str) else s
cstr = lambda s: s.encode("utf8") if isinstance(s, unicode) else s

cmd = sys.argv[1]
title = sys.argv[2]
data = sys.argv[3]
download_dir = sys.argv[4]

cur_directory = os.path.dirname(__file__)
sources_directory = os.path.join(cur_directory,"resources","lib", "content", "sources")
sources = ContentSources.ContentSources(sources_directory)
if not sources.is_video(data):
    print "It is not video link"
    sys.exit(1)

streams = sources.get_streams(data)

if not CLI_MODE:
    ret = xbmcgui.Dialog().select("Select stream",streams)
else:
    ret = 0
stream = streams[ret]
#output =  stream["name"].replace("\\"," ").replace(":"," ").replace("|"," ")
output = re.sub("[\\/\n\r\t,:\?\|'~\.]","_",title)

for sub in stream["subs"]:
    suburl = sub["url"]
    slang = "_" + sub["lang"] if sub["lang"] else ""

    try:
        subs = urllib2.urlopen(suburl).read()
    except:
        subs = None
    if subs:
        if ".xml" in suburl:
            subs = util.ttaf2srt(subs)
            subext = ".srt"
        elif ".vtt" in suburl:
            subext = ".vtt"
        elif ".srt" in suburl:
            subext = ".srt"
        else:
            subext = ""
        if subext:
            subfile = cunicode(os.path.join(download_dir, output+slang+subext))
            with open(subfile,"w") as f:
                f.write(subs)
    else:
        print "\n Error downloading subtitle %s"%suburl

def download_hls(url, title, download_dir="", headers=None, overwrite=True):
    UA = "Mozilla/5.0 (Windows NT 10.0; WOW64; rv:51.0) Gecko/20100101 Firefox/51.0"
    if not headers:
        headers = {"User-Agent" : UA}
    key = headers["key"] if "key" in headers else ""
    if not "User-Agent" in headers:
        headers["User-Agent"] = UA
    tsname = os.path.join(download_dir,title+".ts")
    if not os.path.exists(tsname) or overwrite:
        tsfile = open(tsname,"wb")
        print "Downloading ", tsname
        try:
            r=requests.get(url,headers=headers, verify=False)
        except Exception as e:
            print "Got Exception: ", str(e)
            import traceback
            traceback.print_exc()
            sys.exit()
        ts_list = re.findall(r"#EXTINF:([\d\.]+),\n(.+?)$", r.content, re.IGNORECASE | re.MULTILINE)
        for ts in ts_list:
            url2 = ts[1]
            #print "Downloading ", url2
            #fname = os.path.join(download_dir,url2.split("/")[-1])
            r = requests.get(url2, headers=headers, verify=False)
            content = r.content
            if key:
                from Crypto.Cipher import AES
                key2 = binascii.a2b_hex(key)
                iv = content[:16]
                d = AES.new(key2, AES.MODE_CBC, iv)
                content = d.decrypt(content[16:])
            #with open(fname,"wb") as f:
                #f.write(content)
            tsfile.write(content)
            #lfile.write("file '%s'"%fname)
        #lfile.close()
        tsfile.close()

def download_video(url,output,headers=None):
    #output = stream["name"].replace("\\"," ").replace(":"," ").replace("|"," ")
    if not headers:
        headers = {"user-agent":"Enigma2"}
    try:
        h = get_header(url,headers=headers)
        mtype = h.get("content-type")
        ext,stream_type = get_ext(mtype)
    except:
        ext,stream_type = (".ts","hls")
    output = output+ext
    if stream_type == "hls":
        download_hls(url,output,headers=headers)
    else:
        download_file(output,headers=headers)


#d = Downloader.download_video(stream["url"], os.path.join(download_dir, output), stream["headers"])
#reactor.run()


#xbmcgui.Dialog().ok("Info","Start download")

#mode = "a" if os.path.exists("context_menu.log") else "w"
#with open("context_menu.log", mode) as f:
#    f.write("%s %s %s %s", sys.argv[1], sys.argv[2], sys.argv[3], sys.argv[4])
